<?PHP
/*
Simfatic Forms Main Form processor script

This script does all the server side processing. 
(Displaying the form, processing form submissions,
displaying errors, making CAPTCHA image, and so on.) 

All pages (including the form page) are displayed using 
templates in the 'templ' sub folder. 

The overall structure is that of a list of modules. Depending on the 
arguments (POST/GET) passed to the script, the modules process in sequence. 

Please note that just appending  a header and footer to this script won't work.
To embed the form, use the 'Copy & Paste' code in the 'Take the Code' page. 
To extend the functionality, see 'Extension Modules' in the help.

*/

@ini_set("display_errors", 1);//the error handler is added later in FormProc
error_reporting(E_ALL & ~((defined('E_STRICT')?E_STRICT:0)|E_NOTICE));

require_once(dirname(__FILE__)."/includes/DryCleaningSaving-lib.php");
$formproc_obj =  new SFM_FormProcessor('DryCleaningSaving');
$formproc_obj->initTimeZone('default');
$formproc_obj->setFormID('8689a387-6b54-4fe3-9975-4266e0eb121b');
$formproc_obj->setFormKey('cade76de-e602-4f3e-801c-7842ccd6510f');
$formproc_obj->setLocale('en-US','M/d/yyyy');
$formproc_obj->setEmailFormatHTML(true);
$formproc_obj->EnableLogging(false);
$formproc_obj->SetDebugMode(false);
$formproc_obj->setIsInstalled(true);
$formproc_obj->EnableLoadFormValuesFromURL(true);
$formproc_obj->SetPrintPreviewPage(sfm_readfile(dirname(__FILE__)."/templ/DryCleaningSaving_print_preview_file.txt"));
$formproc_obj->SetSingleBoxErrorDisplay(true);
$formproc_obj->setFormPage(0,sfm_readfile(dirname(__FILE__)."/templ/DryCleaningSaving_form_page_0.txt"));
$formproc_obj->AddElementInfo('NoGarment','decimal','');
$formproc_obj->AddElementInfo('TotalCost','decimal','');
$formproc_obj->AddElementInfo('no_of_garments','calcfield','');
$formproc_obj->AddElementInfo('total_cost','calcfield','');
$formproc_obj->AddElementInfo('cost_per_garment','calcfield','');
$formproc_obj->AddElementInfo('nosaving','calcfield','');
$formproc_obj->AddElementInfo('no_annual_saving','calcfield','');
$formproc_obj->AddElementInfo('percent_saving','calcfield','');
$formproc_obj->AddElementInfo('AnnualSaving','calcfield','');
$formproc_obj->AddElementInfo('our_cost_per_garment','calcfield','');
$formproc_obj->AddElementInfo('our_no_of_garments','calcfield','');
$formproc_obj->AddElementInfo('our_total_cost','calcfield','');
$formproc_obj->AddDefaultValue('NoGarment','0');
$formproc_obj->AddDefaultValue('TotalCost','0');
$formproc_obj->SetHiddenInputTrapVarName('t48141090ce8f37481389');
$page_renderer =  new FM_FormPageDisplayModule();
$formproc_obj->addModule($page_renderer);

$validator =  new FM_FormValidator();
$validator->addValidation("NoGarment","numeric","The input for  should be a valid numeric value");
$validator->addValidation("TotalCost","numeric","The input for  should be a valid numeric value");
$formproc_obj->addModule($validator);

$tupage =  new FM_ThankYouPage(sfm_readfile(dirname(__FILE__)."/templ/DryCleaningSaving_thank_u.txt"));
$formproc_obj->addModule($tupage);

$page_renderer->SetFormValidator($validator);
$formproc_obj->ProcessForm();

?>